creatNode();
function creatNode() {
  var childNode = document.createElement("div");
  childNode.id = "loadingpage";
  childNode.style.height = "100%";
  childNode.style.width = "100%";
  childNode.style.top = 0;
  childNode.style.background = "#000";
  childNode.style.position = "absolute";
  childNode.style.zIndex = 9999;
  var html = document.documentElement;
  html.appendChild(childNode);
}

document.addEventListener("DOMContentLoaded", ready);

//执行逻辑函数
function ready() {
  var hybrid = new Hybrid();
  var myHtml;
  var myVideo;
  var myModalList;
  var myModal;
  //缓冲状态
  var bufferState = 2;

  //控制页面按钮元素
  var videoTitleNode, controlBackground, controlBtn;

  async function init() {
    clearInterval(timer);
    videoTitleNode = window.document.getElementsByClassName(
      "slim-video-metadata-title"
    );
    myVideo.muted = false;
    var isSupportHybrid = await hybrid.isSupportHybrid(); // it will take 200ms if current webview not support hybrid
    if (isSupportHybrid) {
      // do what you want to do with hybrid
      getPlayInfo();
      onPlayStateChange();
      //   onVideoStop();
      hybrid.listenPlayerEvent(type => {
        var backInfo = type;
        var method = backInfo.value.method;
        //控制弹窗的隐藏
        myModalList = window.document.getElementsByClassName(
          "mealbar-promo-renderer"
        );
        myModal = myModalList && myModalList[0];
        if (myModal) {
          myModal.style.visibility = "hidden";
        }

        //控制页面的隐藏
        controlBackground = window.document.getElementById(
          "player-control-overlay"
        );

        controlBtn = window.document.getElementsByClassName(
          "player-controls-content"
        );

        if (controlBackground || controlBtn[0]) {
          controlBackground.style.visibility = "hidden";
          controlBtn[0].style.visibility = "hidden";
        }
        if (method == "play") {
          play();
        } else if (method == "pause") {
          pause();
        } else if (method == "stop") {
          stop();
        } else if (method == "replay") {
          replay();
        } else if (method == "setProgress") {
          let params = backInfo.value.params;
          setProgress(params.value0);
        }
      });
      hybrid.onLog(0);
    }
  }

  var resetTimes = 0;
  var timer = setInterval(function() {
    resetTimes++;
    myVideo = document.getElementsByTagName("video")[0];
    myHtml = document.documentElement;
    if (myVideo) {
      let isYoutube = myVideo.className.indexOf("video-stream") > -1;
      if (isYoutube) {
        resetTimes = 0;
        init();
      }
    } else {
      //如果重试次数大于20，停止重查，上报错误
      if (resetTimes > 20) {
        clearInterval(timer);
        resetTimes = 0;

        hybrid.trackEvent(
          "WatchDog",
          JSON.stringify({
            action: "watch",
            type: "webplayer_js_error",
            str_data: window.location.href,
            number_data: 800
          })
        );
        hybrid.onError(800, "html isnot find video");
      }
    }
  }, 200);

  window.onunload = function() {
    hybrid.stopListenPlayerEvent();
  };

  function play() {
    myVideo.play();
  }

  function pause() {
    myVideo.pause();
  }

  function stop() {
    myVideo.currentTime = myVideo.duration;
  }

  function replay() {
    myVideo.currentTime = 0;
    myVideo.play();
  }

  function setProgress(progress) {
    hybrid.onProgressChanged(progress, myVideo.duration);
    myVideo.currentTime = progress;
  }

  //定义播放信息
  function getPlayInfo() {
    var videoUrl = myVideo.src;
    var videoTitle = videoTitleNode[0].innerHTML;
    var videoDuration = myVideo.duration || 0;
    //播放信息变化监听
    hybrid.onPlayInfoChanged(videoUrl, videoTitle, videoDuration);

    changePageStructure();
  }

  //改变页面结构
  function changePageStructure() {
    var app,
      playerContainerId,
      headerBar,
      headerBarParent,
      watchContent,
      watchContentParent,
      loadingpage;

    //控制页面的填满居中

    myHtml.style.height = "100%";
    myHtml.style.width = "100%";
    myHtml.style.background = "#000";

    myVideo.poster = "https://static.snaptube.in/lottie/blackBg.png";
    try {
      //控制背景的padding
      app = window.document.getElementById("app");

      app.style.padding = 0;

      //控制播放内容的top
      playerContainerId = window.document.getElementById("player-container-id");

      playerContainerId.style.top = "50%";
      playerContainerId.style.transform = "translateY(-50%)";

      // 删除 头部
      headerBar = window.document.getElementById("header-bar");

      headerBarParent = headerBar.parentElement;

      headerBarParent.removeChild(headerBar);

      // 删除 下半部分
      watchContent = window.document.getElementsByClassName("watch-content");

      watchContentParent = watchContent[0].parentElement;

      watchContentParent.removeChild(watchContent[0]);

      //将蒙层去掉
      setTimeout(() => {
        loadingpage = window.document.getElementById("loadingpage");
        loadingpageParent = loadingpage.parentElement;

        loadingpageParent.removeChild(loadingpage);
      }, 1000);
      if (window.document.getElementById("header-bar")) {
        hybrid.trackEvent(
          "WatchDog",
          JSON.stringify({
            action: "watch",
            type: "webplayer_js_error",
            str_data: window.location.href,
            number_data: 801
          })
        );

        hybrid.onError(801, "headerBar or BottomItem didn't remove");
      }
    } catch (error) {
      hybrid.trackEvent(
        "WatchDog",
        JSON.stringify({
          action: "watch",
          type: "webplayer_js_error",
          str_data: error,
          number_data: 803
        })
      );
      hybrid.trackEvent(
        "WatchDog",
        JSON.stringify({
          action: "watch",
          type: "webplayer_js_error",
          str_data: window.location.href,
          number_data: 802
        })
      );
      hybrid.onError(802, error);
    }
  }

  //对播放，暂停，缓冲，错误事件进行监听
  function onPlayStateChange() {
    myVideo.addEventListener(
      "play",
      function(data) {
        hybrid.onPlayStateChanged(1);
      },
      false
    );
    myVideo.addEventListener(
      "pause",
      function(data) {
        hybrid.onPlayStateChanged(2);
      },
      false
    );
    myVideo.addEventListener(
      "ended",
      function(data) {
        hybrid.onPlayStateChanged(3);
      },
      false
    );
    myVideo.addEventListener(
      "error",
      function(data) {
        let errorMsg = JSON.stringify(data);
        hybrid.onError(700, errorMsg);
      },
      false
    );

    myVideo.addEventListener(
      "timeupdate",
      function() {
        var timeDisplay;
        //用秒数来显示当前播放进度
        if (myVideo && myVideo.currentTime && myVideo.duration) {
          timeDisplay = myVideo.currentTime;
          isBuffer();
          hybrid.onProgressChanged(timeDisplay, myVideo.duration);
        }
      },
      false
    );
  }

  function isBuffer() {
    //判断是否在缓冲中
    if (myVideo.buffered.length > 0) {
      var buffer = myVideo.buffered.end(0);
      var timeDiff = buffer - myVideo.currentTime;
      let curBufferState = bufferState;
      if (timeDiff < 0.1) {
        curBufferState = 1;
      } else {
        curBufferState = 2;
      }
      if (bufferState != curBufferState) {
        hybrid.onBufferStateChanged(curBufferState);
        bufferState = curBufferState;
      }
    } else {
      hybrid.onBufferStateChanged(2);
    }
  }
}
